Package org.eclipse.app4mc.amalthea.model.util

## Class FactoryUtil

- Object
- - FactoryUtil

    public class FactoryUtil
    extends Object

### Method Summary

All Methods
`static ClockStep` `createClockStep​(double freqValue, FrequencyUnit freqUnit, long timeValue, String timeUnit)`
`static Counter` `createCounter​(long prescaler)` Creates a counter (with offset = 0)
`static Counter` `createCounter​(long prescaler, long offset)` Creates a counter
`static DataRate` `createDataRate()` Creates a data rate (initialized with zero value and base unit)
`static DataRate` `createDataRate​(long value, DataRateUnit unit)` Creates a data rate out of a value and a unit
`static DataSize` `createDataSize()` Creates a data size (initialized with zero value and base unit)
`static DataSize` `createDataSize​(long value, DataSizeUnit unit)` Creates a data size out of a value and a unit
`static DiscreteValueBoundaries` `createDiscreteValueBoundaries​(long min, long max)`
`static DiscreteValueConstant` `createDiscreteValueConstant​(long value)`
`static DiscreteValueGaussDistribution` `createDiscreteValueGaussDistribution​(double mean, double sd)`
`static DiscreteValueGaussDistribution` `createDiscreteValueGaussDistribution​(double mean, double sd, Long min, Long max)`
`static ExecutionNeed` `createExecutionNeed​(String featureCategory, IDiscreteValueDeviation usages)` Creates ExecutionNeed for a featureCategoryName, need set.
`static ExecutionNeed` `createExecutionNeed​(HwFeature feature, IDiscreteValueDeviation usages)` Creates ExecutionNeed for a feature, need set.
`static Frequency` `createFrequency()` Creates a frequency (initialized with zero value and base unit)
`static Frequency` `createFrequency​(double value, FrequencyUnit unit)` Creates a frequency out of a value and a unit
`static DiscreteValueConstant` `createLatency​(long value)`
`static Time` `createTime()` Creates a time (initialized with zero value and base unit)
`static Time` `createTime​(double value, String unit)` Creates a time out of a value and a unit given as String.
`static Time` `createTime​(double value, TimeUnit unit)` Creates a time out of a value and a unit (converted to pico seconds)
`static Time` `createTime​(long value, String unit)` Creates a time out of a value and a unit given as String.
`static Time` `createTime​(long value, TimeUnit unit)` Creates a time out of a value and a unit
`static Time` `createTime​(String timeString)` Creates a Time object parsed from a text representation.
`static Time` `createTime​(BigInteger value, String unit)` Creates a time out of a value and a unit given as String.
`static Time` `createTime​(BigInteger value, TimeUnit unit)` Creates a time out of a value and a unit
`static Time` `createTime​(Time inputTime)` Creates a new time based on a time
`static TimeBoundaries` `createTimeBoundaries​(Time min, Time max)`
`static TimeConstant` `createTimeConstant​(Time value)`
`static TimeGaussDistribution` `createTimeGaussDistribution​(Time mean, Time sd)`
`static TimeGaussDistribution` `createTimeGaussDistribution​(Time mean, Time sd, Time min, Time max)`
`static TypeRef` `createTypeRef​(TypeDefinition typeDefinition)` Creates a TypeRef object that refers to a type definition
`static Voltage` `createVoltage()` Creates a voltage (initialized with zero value and base unit)
`static Voltage` `createVoltage​(double value, VoltageUnit unit)` Creates a voltage out of a value and a unit
`static DiscreteValueWeibullEstimatorsDistribution` `createWeibullDistribution​(long min, double avg, long max, double promille)`
`static TimeWeibullEstimatorsDistribution` `createWeibullDistribution​(Time min, Time avg, Time max, double promille)`

### Methods inherited from class Object

`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Method Detail

#### createCounter

    public static Counter createCounter​(long prescaler)

Creates a counter (with offset = 0)

#### createCounter

    public static Counter createCounter​(long prescaler,
                                        long offset)

Creates a counter

#### createDataSize

    public static DataSize createDataSize()

Creates a data size (initialized with zero value and base unit)

#### createDataSize

    public static DataSize createDataSize​(long value,
                                          DataSizeUnit unit)

Creates a data size out of a value and a unit

#### createDataRate

    public static DataRate createDataRate()

Creates a data rate (initialized with zero value and base unit)

#### createDataRate

    public static DataRate createDataRate​(long value,
                                          DataRateUnit unit)

Creates a data rate out of a value and a unit

#### createFrequency

    public static Frequency createFrequency()

Creates a frequency (initialized with zero value and base unit)

#### createFrequency

    public static Frequency createFrequency​(double value,
                                            FrequencyUnit unit)

Creates a frequency out of a value and a unit

#### createVoltage

    public static Voltage createVoltage()

Creates a voltage (initialized with zero value and base unit)

#### createVoltage

    public static Voltage createVoltage​(double value,
                                        VoltageUnit unit)

Creates a voltage out of a value and a unit

#### createTime

    public static Time createTime()

Creates a time (initialized with zero value and base unit)

#### createTime

    public static Time createTime​(Time inputTime)

Creates a new time based on a time

Parameters:
  `inputTime` -
Returns:
  New time object

#### createTime

    public static Time createTime​(long value,
                                  TimeUnit unit)

Creates a time out of a value and a unit

#### createTime

    public static Time createTime​(double value,
                                  TimeUnit unit)

Creates a time out of a value and a unit (converted to pico seconds)

#### createTime

    public static Time createTime​(BigInteger value,
                                  TimeUnit unit)

Creates a time out of a value and a unit

#### createTime

    public static Time createTime​(long value,
                                  String unit)

Creates a time out of a value and a unit given as String.

#### createTime

    public static Time createTime​(double value,
                                  String unit)

Creates a time out of a value and a unit given as String.

#### createTime

    public static Time createTime​(BigInteger value,
                                  String unit)

Creates a time out of a value and a unit given as String.

#### createTime

    public static Time createTime​(String timeString)

Creates a Time object parsed from a text representation.

Parameters:
  `timeString` - string representation of a time (number followed by time unit s, ms, us, ns or ps)
Returns:
  The new Time object

#### createClockStep

    public static ClockStep createClockStep​(double freqValue,
                                            FrequencyUnit freqUnit,
                                            long timeValue,
                                            String timeUnit)

#### createTypeRef

    public static TypeRef createTypeRef​(TypeDefinition typeDefinition)

Creates a TypeRef object that refers to a type definition

#### createDiscreteValueConstant

    public static DiscreteValueConstant createDiscreteValueConstant​(long value)

#### createDiscreteValueBoundaries

    public static DiscreteValueBoundaries createDiscreteValueBoundaries​(long min,
                                                                        long max)

#### createDiscreteValueGaussDistribution

    public static DiscreteValueGaussDistribution createDiscreteValueGaussDistribution​(double mean,
                                                                                      double sd)

#### createDiscreteValueGaussDistribution

    public static DiscreteValueGaussDistribution createDiscreteValueGaussDistribution​(double mean,
                                                                                      double sd,
                                                                                      Long min,
                                                                                      Long max)

#### createWeibullDistribution

    public static DiscreteValueWeibullEstimatorsDistribution createWeibullDistribution​(long min,
                                                                                       double avg,
                                                                                       long max,
                                                                                       double promille)

#### createTimeConstant

    public static TimeConstant createTimeConstant​(Time value)

#### createTimeBoundaries

    public static TimeBoundaries createTimeBoundaries​(Time min,
                                                      Time max)

#### createTimeGaussDistribution

    public static TimeGaussDistribution createTimeGaussDistribution​(Time mean,
                                                                    Time sd)

#### createTimeGaussDistribution

    public static TimeGaussDistribution createTimeGaussDistribution​(Time mean,
                                                                    Time sd,
                                                                    Time min,
                                                                    Time max)

#### createWeibullDistribution

    public static TimeWeibullEstimatorsDistribution createWeibullDistribution​(Time min,
                                                                              Time avg,
                                                                              Time max,
                                                                              double promille)

#### createExecutionNeed

    public static ExecutionNeed createExecutionNeed​(String featureCategory,
                                                    IDiscreteValueDeviation usages)

Creates ExecutionNeed for a featureCategoryName, need set.

#### createExecutionNeed

    public static ExecutionNeed createExecutionNeed​(HwFeature feature,
                                                    IDiscreteValueDeviation usages)

Creates ExecutionNeed for a feature, need set.

#### createLatency

    public static DiscreteValueConstant createLatency​(long value)